package com.aliyun.vodplayer.demo;

import android.Manifest;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

import com.aliyun.vodplayer.demo.activity.DemoAuthInfoActivity;
import com.aliyun.vodplayer.demo.activity.DemoDownloadActivity;
import com.aliyun.vodplayer.demo.activity.DemoLocalSourceActivity;
import com.aliyun.vodplayer.demo.activity.DemoMultiPlayerActivity;
import com.aliyun.vodplayer.demo.activity.DemoSourceVidActivity;
import com.aliyun.vodplayer.demo.activity.DemoSwitchActivity;
import com.aliyun.vodplayer.demo.activity.NoSkinActivity;
import com.aliyun.vodplayer.media.AliyunVodPlayer;

public class DemoMainActivity extends AppCompatActivity {

    private int STORAGE_REQUEST_CODE = 100;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_demo_main);


        //有信息泄漏风险，此方法不建议使用、
        /*findViewById(R.id.datasource).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent();
                intent.setClass(DemoMainActivity.this,DemoDataSourceActivity.class);
                startActivity(intent);
            }
        });*/


        //建议使用此方法。
        findViewById(R.id.authinfo).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                int storagePermissionRet = ContextCompat.checkSelfPermission(DemoMainActivity.this, Manifest.permission.WRITE_EXTERNAL_STORAGE);
                if (storagePermissionRet != PackageManager.PERMISSION_GRANTED) {
                    requestPermission();
                    return;
                }

                Intent intent = new Intent();
                intent.putExtra("type", "noskin");

                intent.setClass(DemoMainActivity.this, DemoAuthInfoActivity.class);
                startActivity(intent);
            }
        });

        findViewById(R.id.local).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                int storagePermissionRet = ContextCompat.checkSelfPermission(DemoMainActivity.this, Manifest.permission.WRITE_EXTERNAL_STORAGE);
                if (storagePermissionRet != PackageManager.PERMISSION_GRANTED) {
                    requestPermission();
                    return;
                }

                Intent intent = new Intent();
                intent.setClass(DemoMainActivity.this, DemoLocalSourceActivity.class);
                startActivity(intent);
            }
        });

        findViewById(R.id.download_vid).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                int storagePermissionRet = ContextCompat.checkSelfPermission(DemoMainActivity.this, Manifest.permission.WRITE_EXTERNAL_STORAGE);
                if (storagePermissionRet != PackageManager.PERMISSION_GRANTED) {
                    requestPermission();
                    return;
                }

                Intent intent = new Intent();
                intent.setClass(DemoMainActivity.this, DemoDownloadActivity.class);
                startActivity(intent);
            }
        });

        findViewById(R.id.player_list).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent();
                intent.setClass(DemoMainActivity.this, DemoMultiPlayerActivity.class);
                startActivity(intent);
            }
        });

        findViewById(R.id.switch_url).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent();
                intent.setClass(DemoMainActivity.this, DemoSwitchActivity.class);
                startActivity(intent);
            }
        });
        findViewById(R.id.web_diagnosis).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent();
                intent.setClass(DemoMainActivity.this, DemoSourceVidActivity.class);
                startActivity(intent);
            }
        });
        findViewById(R.id.ui_player).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                int storagePermissionRet = ContextCompat.checkSelfPermission(DemoMainActivity.this, Manifest.permission.WRITE_EXTERNAL_STORAGE);
                if (storagePermissionRet != PackageManager.PERMISSION_GRANTED) {
                    requestPermission();
                    return;
                }

                Intent intent = new Intent();
                intent.setClass(DemoMainActivity.this, DemoAuthInfoActivity.class);
                //将vid和authinfo传递过去
                intent.putExtra("type", "skin");

                startActivity(intent);
            }
        });
//        findViewById(R.id.vid_player).setOnClickListener(new View.OnClickListener() {
//            @Override
//            public void onClick(View v) {
//                Intent intent = new Intent();
//                intent.setClass(DemoMainActivity.this,DemoVidSourceActivity.class);
//                startActivity(intent);
//            }
//        });

        TextView version = (TextView) findViewById(R.id.version);

        version.setText("v" + AliyunVodPlayer.getSDKVersion());


    }

    private void requestPermission() {
        if (ContextCompat.checkSelfPermission(this, Manifest.permission.WRITE_EXTERNAL_STORAGE)
                != PackageManager.PERMISSION_GRANTED) {
            // 向用户解释为什么需要这个权限
            new AlertDialog.Builder(this)
                    .setMessage("下载视频，边播边存以及播放本地视频，需要SD卡权限。")
                    .setPositiveButton("确定", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            //申请权限
                            ActivityCompat.requestPermissions(DemoMainActivity.this,
                                    new String[]{Manifest.permission.WRITE_EXTERNAL_STORAGE}, STORAGE_REQUEST_CODE);
                        }
                    })
                    .show();

        }
    }

}
