package com.aliyun.vodplayer.demo.activity;

import android.content.Intent;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.support.annotation.RequiresApi;
import android.support.v7.app.AppCompatActivity;
import android.text.TextUtils;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.aliyun.vodplayer.demo.DemoMainActivity;
import com.aliyun.vodplayer.demo.R;
import com.aliyun.vodplayer.demo.utils.PlayAuthUtil;

import org.json.JSONObject;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;

import static com.aliyun.vodplayer.demo.R.id.vid;

/**
 * @Author: lifujun@alibaba-inc.com
 * @Date: 2017/1/9.
 * @Description:
 */

public class DemoAuthInfoActivity extends AppCompatActivity {

    private EditText mVidEdit;
    private EditText mAuthInfoEdit;

    private String mVid = null;
    private String mAuthinfo = null;

    private String mType = "noskin";

    private Button fixedBtn = null;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_demo_authinfo);
        //填写vid和authinfo。
        mVidEdit = (EditText) findViewById(vid);
        mAuthInfoEdit = (EditText) findViewById(R.id.authinfo);

        //点击事件
        findViewById(R.id.no_skin).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                startNoSkinActivity(false);
            }
        });
        /*findViewById(R.id.with_skin).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                startSkinActivity();
            }
        });*/

        if (getIntent().getStringExtra("type") != null) {
            mType = getIntent().getStringExtra("type");

            if (mType.equals("skin")) {
                fixedBtn = (Button) findViewById(R.id.with_skin);
                fixedBtn.setVisibility(View.VISIBLE);
            }
        }

        if (fixedBtn != null) {
            fixedBtn.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    startNoSkinActivity(true);
                }
            });
        }
    }

    private boolean inRequest = false;

    private void startNoSkinActivity(final boolean fixed) {

        mVid = mVidEdit.getText().toString();
        mAuthinfo = mAuthInfoEdit.getText().toString();
        if (TextUtils.isEmpty(mVid) || TextUtils.isEmpty(mAuthinfo)) {
            Toast.makeText(getApplicationContext(), "有信息没有填写", Toast.LENGTH_LONG).show();
            return;
        }

        if (inRequest) {
            return;
        }

        inRequest = true;

        if (mAuthinfo != null) {
            inRequest = false;
            Intent intent = new Intent();
            if (mType.equals("noskin")) {
                intent.setClass(this, NoSkinActivity.class);
            } else if (!fixed) {
                intent.setClass(this, SkinActivity.class);
            } else {
                intent.setClass(this, FixedSkinActivity.class);
            }
            //将vid和authinfo传递过去
            intent.putExtra("type", "authInfo");
            intent.putExtra("vid", mVid);
            intent.putExtra("authinfo", mAuthinfo);

            startActivity(intent);
        }
    }
}
