package com.aliyun.vodplayer.demo.activity;

import android.content.Intent;
import android.os.Build;
import android.os.Bundle;
import android.support.annotation.RequiresApi;
import android.support.v7.app.AppCompatActivity;
import android.text.TextUtils;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.aliyun.vodplayer.demo.R;
import com.aliyun.vodplayer.demo.utils.AuthInfoUtil;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;

import static com.aliyun.vodplayer.demo.R.id.vid;

/**
 * @Author: lifujun@alibaba-inc.com
 * @Date: 2017/1/9.
 * @Description:
 */

public class DemoVidSourceActivity extends AppCompatActivity {

    private EditText mVidEdit;
    private EditText mAuthInfoEdit;

    private String mVid = null;
    private String mAuthinfo = null;

    private String mTmpAks = null;
    private String mTmpAkid = null;
    private String mTmpToken = null;

    private String mType = "noskin";

    private Button fixedBtn = null;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_demo_authinfo);
        //填写vid和authinfo。
        mVidEdit = (EditText) findViewById(vid);
        mAuthInfoEdit = (EditText) findViewById(R.id.authinfo);

        //点击事件
        findViewById(R.id.no_skin).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                try {
                    startNoSkinActivity(false);
                } catch (JSONException e) {
                    e.printStackTrace();
                }
            }
        });
        /*findViewById(R.id.with_skin).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                startSkinActivity();
            }
        });*/

        if(getIntent().getStringExtra("type") != null) {
            mType = getIntent().getStringExtra("type");

            if(mType.equals("skin")) {
                fixedBtn = (Button) findViewById(R.id.with_skin);
                fixedBtn.setVisibility(View.VISIBLE);
            }
        }

        if(fixedBtn != null) {
            fixedBtn.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    try {
                        startNoSkinActivity(true);
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }
                }
            });
        }
    }

    private void startNoSkinActivity(boolean fixed) throws JSONException {
        mAuthinfo = null;
        mVid  = mVidEdit.getText().toString();
        if (TextUtils.isEmpty(mVid)) {
            Toast.makeText(getApplicationContext(), "有信息没有填写", Toast.LENGTH_LONG).show();
            return;
        }
        mAuthinfo = mAuthInfoEdit.getText().toString();
        if(mAuthinfo == null || mAuthinfo.isEmpty()) {
            new Thread(new Runnable() {

                @RequiresApi(api = Build.VERSION_CODES.KITKAT)
                @Override
                public void run() {
                    try {
                        String aks = null;
                        String akid = null;
                        String token = null;
                        URL url = new URL("http://30.40.53.9:9988/?sts=1");
                        HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
                        if(urlConnection == null) {
                            return;
                        }
                        try {
                            InputStream is = new BufferedInputStream(urlConnection.getInputStream());

                            final char[] buffer = new char[1024 * 10];
                            final StringBuilder out = new StringBuilder();
                            try (Reader in = new InputStreamReader(is, "UTF-8")) {
                                for (; ; ) {
                                    int rsz = in.read(buffer, 0, buffer.length);
                                    if (rsz < 0)
                                        break;
                                    out.append(buffer, 0, rsz);
                                }
                            } catch (UnsupportedEncodingException ex) {
                            } catch (IOException ex) {
                            }
                            String jsonAuthinfo = out.toString().replaceAll("u'", "\"").replace("'", "\"");
                            try {
                                JSONObject authinfo = new JSONObject(jsonAuthinfo);
                                String crendt = authinfo.get("Credentials").toString();

                                JSONObject credinfo = new JSONObject(crendt);
                                aks = credinfo.get("AccessKeySecret").toString();
                                akid = credinfo.get("AccessKeyId").toString();
                                token = credinfo.get("SecurityToken").toString();
                            } catch (Exception e) {
                            }
                        } finally {
                            urlConnection.disconnect();
                            mTmpAks = aks;
                            mTmpAkid = akid;
                            mTmpToken = token;
                        }
                    } catch (MalformedURLException e) {
                        e.printStackTrace();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
            }).start();

            int tryCount = 0;
            while (mTmpToken == null || mTmpToken.isEmpty()) {
                try {
                    Thread.sleep(1000);
                    tryCount++;
                    if(tryCount > 500) {
                        Toast.makeText(DemoVidSourceActivity.this, "通过网络实时获取authinfo失败", Toast.LENGTH_SHORT).show();
                        break;
                    }
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        }

        if(mTmpToken != null) {

            Intent intent = new Intent();
            if (mType.equals("noskin")) {
                intent.setClass(this, NoSkinActivity.class);
            } else if (!fixed) {
                intent.setClass(this, SkinActivity.class);
            } else {
                intent.setClass(this, FixedSkinActivity.class);
            }

            AuthInfoUtil authInfoUtil = new AuthInfoUtil();
            authInfoUtil.setExpireTime("2017-09-01T23:59:59Z");
            authInfoUtil.setMediaId(mVid);
            authInfoUtil.setSecret("key1234");
            mAuthinfo = authInfoUtil.generateSign();
            JSONObject authin = new JSONObject();
            authin.put("ExpireTime","2017-09-01T23:59:59Z");
            authin.put("MediaId",mVid);
            authin.put("Signature",mAuthinfo);
            //将vid和authinfo传递过去
            intent.putExtra("type", "vidSource");
            intent.putExtra("vid", mVid);
            intent.putExtra("authinfo", authin.toString());
            intent.putExtra("token", mTmpToken);
            intent.putExtra("aks", mTmpAks);
            intent.putExtra("akid", mTmpAkid);

            startActivity(intent);
        }
    }
}
