package com.aliyun.vodplayer.demo.activity;

import android.Manifest;
import android.content.pm.PackageManager;
import android.content.res.Configuration;
import android.graphics.Color;
import android.media.MediaRecorder;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.support.annotation.IdRes;
import android.support.annotation.RequiresApi;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.ScrollView;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;

import com.aliyun.vodplayer.demo.R;
import com.aliyun.vodplayer.demo.utils.Formatter;
import com.aliyun.vodplayer.demo.utils.PlayAuthUtil;
import com.aliyun.vodplayer.downloader.AliyunDownloadInfoListener;
import com.aliyun.vodplayer.downloader.AliyunDownloadManager;
import com.aliyun.vodplayer.downloader.AliyunDownloadMediaInfo;
import com.aliyun.vodplayer.downloader.AliyunRefreshPlayAuthCallback;
import com.aliyun.vodplayer.media.AliyunDataSource;
import com.aliyun.vodplayer.media.AliyunErrorCode;
import com.aliyun.vodplayer.media.AliyunLocalSource;
import com.aliyun.vodplayer.media.AliyunPlayAuth;
import com.aliyun.vodplayer.media.AliyunVidSource;
import com.aliyun.vodplayer.media.AliyunVodPlayer;
import com.aliyun.vodplayer.media.IAliyunVodPlayer;
import com.aliyun.vodplayer.utils.VcPlayerLog;
import com.aliyun.vodplayerview.utils.ScreenUtils;

import org.json.JSONObject;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static com.aliyun.vodplayer.media.IAliyunVodPlayer.PlayerState.Idle;
import static com.aliyun.vodplayer.media.IAliyunVodPlayer.PlayerState.Stopped;

public class NoSkinActivity extends AppCompatActivity {

    private static final String TAG = NoSkinActivity.class.getSimpleName();

    private SimpleDateFormat format = new SimpleDateFormat("HH:mm:ss.SS");

    private SurfaceView surfaceView;

    /*private Button prepareBtn;*/
    private Button playBtn;
    private Button pauseBtn;
    /*private Button releaseBtn;
    private Button changeQualityBtn;*/
    private Button replayBtn;
    private Button stopBtn;
    /*private Button downBtn;*/
    /*private Button downStopBtn;*/

    private RadioGroup autoPlayGroup;
    private RadioButton autoPlayOnBtn;
    private RadioButton autoPlayOffBtn;

    private RadioGroup muteGroup;
    private RadioButton muteOnBtn;
    private RadioButton muteOffBtn;

    private RadioGroup scaleModeGroup;
    private RadioButton scaleModeFit;
    private RadioButton scaleModeFill;

    private LinearLayout qualityLayout;

    private AliyunDownloadMediaInfo downloadInfo;
    private AliyunDownloadManager aliyunDownloadManager;

    private TextView positionTxt;
    private TextView durationTxt;
    private SeekBar progressBar;

    private SeekBar brightnessBar;
    private SeekBar volumeBar;

    private TextView videoWidthTxt;
    private TextView videoHeightTxt;

    public static boolean sAutoPlay = false;
    public boolean mAutoPlay = false;
    private boolean mMute= false;
    private int mScalingMode = 1; //fill
    private List<String> mQualities = new ArrayList<>();
    private List<Button> qualityIds = new ArrayList<>();

    private List<String> logStrs = new ArrayList<>();

    private AliyunVodPlayer aliyunVodPlayer;
    private Handler handler = new Handler();

    private boolean replay = false;
    private boolean inSeek = false;
    private boolean isCompleted = false;

    private String mVid = null;
    private String mAuthinfo = null;
    private Map<String,String> qualityList = new HashMap<>();

    private AliyunPlayAuth mPlayAuth = null;
//    private AliyunDataSource mDataSource = null;
    private AliyunLocalSource mLocalSource = null;
    private AliyunVidSource mVidSource = null;

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.menu_log, menu);
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        if(item.getItemId() == R.id.log) {

            LayoutInflater inflater= LayoutInflater.from(this);
            View view=inflater.inflate(R.layout.view_log, null);

            TextView textview=(TextView)view.findViewById(R.id.log);
            if(aliyunVodPlayer != null) {
                for(String log: logStrs) {
                    textview.append("     "+log+"\n");
                }
            }
            AlertDialog.Builder alertDialog = new AlertDialog.Builder(this);
            alertDialog.setTitle("播放器日志：");
            alertDialog.setView(view);
            alertDialog.setPositiveButton("OK",null);
            AlertDialog alert = alertDialog.create();
            alert.show();
        }
        return true;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_noskin);

        surfaceView = (SurfaceView) findViewById(R.id.surfaceView);

        /*prepareBtn = (Button) findViewById(R.id.prepare);*/
        playBtn = (Button) findViewById(R.id.play);
        stopBtn = (Button) findViewById(R.id.stop);
        pauseBtn = (Button) findViewById(R.id.pause);
        /*releaseBtn = (Button) findViewById(R.id.release);*/
        /*changeQualityBtn = (Button) findViewById(R.id.change_quality);*/
        replayBtn = (Button) findViewById(R.id.replay);
        /*downBtn = (Button) findViewById(R.id.download);*/
        /*downStopBtn = (Button) findViewById(R.id.downloadStop);*/

        qualityLayout = (LinearLayout) findViewById(R.id.quality);

        autoPlayGroup = (RadioGroup) findViewById(R.id.autoPlay);
        autoPlayOnBtn = (RadioButton) findViewById(R.id.autoPlayON);
        autoPlayOffBtn = (RadioButton) findViewById(R.id.autoPlayOff);

        if(sAutoPlay) {
            autoPlayOnBtn.setChecked(true);
        } else {
            autoPlayOffBtn.setChecked(true);
        }

        autoPlayGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, @IdRes int checkedId) {
                if(checkedId==autoPlayOnBtn.getId())
                {
                    sAutoPlay = true;
                }
                else if(checkedId==autoPlayOffBtn.getId())
                {
                    sAutoPlay = false;
                }
            }
        });

        muteGroup = (RadioGroup) findViewById(R.id.mute);
        muteOnBtn = (RadioButton) findViewById(R.id.muteOn);
        muteOffBtn = (RadioButton) findViewById(R.id.muteOff);

        muteOffBtn.setChecked(true);

        muteGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, @IdRes int checkedId) {
                if(checkedId==muteOnBtn.getId())
                {
                    mMute = true;
                    if(aliyunVodPlayer != null) {
                        aliyunVodPlayer.setMuteMode(mMute);
                    }
                    volumeBar.setProgress(0);
                }
                else if(checkedId==muteOffBtn.getId())
                {
                    mMute = false;
                    if(aliyunVodPlayer != null) {
                        aliyunVodPlayer.setMuteMode(mMute);
                    }
                    volumeBar.setProgress(aliyunVodPlayer.getVolume());
                }
            }
        });

        scaleModeGroup = (RadioGroup) findViewById(R.id.scalingMode);
        scaleModeFit = (RadioButton) findViewById(R.id.fit);
        scaleModeFill = (RadioButton) findViewById(R.id.fill);

        scaleModeFit.setChecked(true);

        scaleModeGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, @IdRes int checkedId) {
                if(checkedId==scaleModeFit.getId())
                {
                    mScalingMode = 0;
                    if(aliyunVodPlayer != null) {
                        aliyunVodPlayer.setVideoScalingMode(IAliyunVodPlayer.VideoScalingMode.VIDEO_SCALING_MODE_SCALE_TO_FIT);
                    }
                }
                else if(checkedId==scaleModeFill.getId())
                {
                    mScalingMode = 1;
                    if(aliyunVodPlayer != null) {
                        aliyunVodPlayer.setVideoScalingMode(IAliyunVodPlayer.VideoScalingMode.VIDEO_SCALING_MODE_SCALE_TO_FIT_WITH_CROPPING);
                    }
                }
            }
        });

        positionTxt = (TextView) findViewById(R.id.currentPosition);
        durationTxt = (TextView) findViewById(R.id.totalDuration);
        progressBar = (SeekBar) findViewById(R.id.progress);
        brightnessBar = (SeekBar) findViewById(R.id.brightnessProgress);
        volumeBar = (SeekBar) findViewById(R.id.volumeProgress);

        videoWidthTxt = (TextView) findViewById(R.id.width);
        videoHeightTxt = (TextView) findViewById(R.id.height);
//        prepareBtn.setOnClickListener(new View.OnClickListener() {
//            @Override
//            public void onClick(View v) {
//                aliyunVodPlayer.prepareAsync();
//            }
//        });
        playBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                mPlayerState = aliyunVodPlayer.getPlayerState();
                if(mPlayerState == Idle || mPlayerState == Stopped) {
                    if(mVidSource != null) {
                        aliyunVodPlayer.prepareAsync(mVidSource);
                    } else if(mPlayAuth != null) {
                        aliyunVodPlayer.prepareAsync(mPlayAuth);
                    } else if(mLocalSource != null) {
                        aliyunVodPlayer.prepareAsync(mLocalSource);
                    }
//                    else {
//                        aliyunVodPlayer.prepareAsync(mDataSource);
//                    }
                    mAutoPlay = true;
                } else {
                    inSeek = false;
                    aliyunVodPlayer.start();
                    pauseBtn.setText("暂停");
                }
                if(mMute) {
                    aliyunVodPlayer.setMuteMode(mMute);
                }
                brightnessBar.setProgress(aliyunVodPlayer.getScreenBrightness());
                logStrs.add(format.format(new Date()) + " 开始请求播放");
                volumeBar.setProgress(aliyunVodPlayer.getVolume());
            }
        });
        stopBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(aliyunVodPlayer != null) {
                    aliyunVodPlayer.stop();
                }
            }
        });

        pauseBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                mPlayerState = aliyunVodPlayer.getPlayerState();
                if (mPlayerState == IAliyunVodPlayer.PlayerState.Started) {
                    aliyunVodPlayer.pause();
                    pauseBtn.setText("继续");
                } else if (mPlayerState == IAliyunVodPlayer.PlayerState.Paused) {
                    aliyunVodPlayer.resume();
                    pauseBtn.setText("暂停");
                }
            }
        });
        /*releaseBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                aliyunVodPlayer.stop();
                aliyunVodPlayer.release();
            }
        });
        changeQualityBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                aliyunVodPlayer.changeQuality(IAliyunVodPlayer.QualityValue.QUALITY_FLUENT);
            }
        });*/
        replayBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                isCompleted = false;
                inSeek = false;
                aliyunVodPlayer.replay();
                showVideoProgressInfo();
            }
        });


        progressBar.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                if (fromUser
                        && aliyunVodPlayer != null
                        ) {
                    aliyunVodPlayer.seekTo(progress);
                    logStrs.add(format.format(new Date()) + " seek开始");
                    if(isCompleted) {
                        //播放完成了，不能seek了
                        inSeek = false;
                    }else{
                        inSeek = true;
                    }
                }
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });

        brightnessBar.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {

                if (fromUser && aliyunVodPlayer != null) {
                    aliyunVodPlayer.setScreenBrightness(progress);
                }
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });

        volumeBar.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {

                if (fromUser && aliyunVodPlayer != null) {
                    aliyunVodPlayer.setVolume(progress);
                    muteOffBtn.setChecked(true);
                }
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });


        surfaceView.getHolder().addCallback(new SurfaceHolder.Callback() {
            @Override
            public void surfaceCreated(SurfaceHolder holder) {
                Log.d(TAG, "surfaceCreated");
                aliyunVodPlayer.setDisplay(holder);
            }

            @Override
            public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {
                Log.d(TAG, "surfaceChanged");
                aliyunVodPlayer.surfaceChanged();
            }

            @Override
            public void surfaceDestroyed(SurfaceHolder holder) {
                Log.d(TAG, "surfaceDestroyed");
            }
        });

        initVodPlayer();
        setPlaySource();
        logStrs.add(format.format(new Date())+" 准备请求码流");

        if(mVidSource != null) {
            aliyunVodPlayer.prepareAsync(mVidSource);
        } else if(mPlayAuth != null) {
            aliyunVodPlayer.prepareAsync(mPlayAuth);
        } else if(mLocalSource != null) {
            aliyunVodPlayer.prepareAsync(mLocalSource);
        }
//        else {
//            aliyunVodPlayer.prepareAsync(mDataSource);
//        }


        aliyunDownloadManager = AliyunDownloadManager.getInstance(NoSkinActivity.this.getApplicationContext());
        /*downBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                donwloadVideo();
            }
        });
        downStopBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(downloadInfo != null) {
                    aliyunDownloadManager.stopDownloadMedia(downloadInfo);
                }
            }
        });*/
        qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_FLUENT,"流畅");
        qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_LOW,"标清");
        qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_STAND,"高清");
        qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_HIGH,"超清");
        qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_2K,"2k");
        qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_4K,"4k");
        qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_ORIGINAL,"原画");
    }

    private void initVodPlayer() {
        aliyunVodPlayer = new AliyunVodPlayer(this);
        String sdDir = Environment.getExternalStorageDirectory().getAbsolutePath() + "/test_save_cache";
        aliyunVodPlayer.setPlayingCache(true,sdDir,60 * 60 /*时长, s */,300 /*大小，MB*/);
        aliyunVodPlayer.setOnPreparedListener(new IAliyunVodPlayer.OnPreparedListener() {
            @Override
            public void onPrepared() {
                Toast.makeText(NoSkinActivity.this, "准备成功", Toast.LENGTH_SHORT).show();
                logStrs.add(format.format(new Date())  + " 准备成功");
                //准备成功之后可以调用start方法开始播放
                inSeek = false;
                showVideoProgressInfo();
                showVideoSizeInfo();

                qualityLayout.removeAllViews();

                if(mLocalSource == null) {
                    qualityIds.clear();
                    mQualities = aliyunVodPlayer.getMediaInfo().getQualities();
                    String current = aliyunVodPlayer.getCurrentQuality();
                    //update quality buttons
                    for (String quality : mQualities) {
                        Button btn = new Button(getBaseContext());
                        LinearLayout.LayoutParams layoutParams = new LinearLayout.LayoutParams(
                                LinearLayout.LayoutParams.WRAP_CONTENT, LinearLayout.LayoutParams.MATCH_PARENT);

                        layoutParams.setMargins(10, 0, 10, 0);
                        btn.setText(qualityList.get(quality));
                        btn.setTextSize(14);
                        btn.setTag(quality);
                        btn.setTextColor(Color.rgb(49, 50, 51));
                        btn.setBackgroundColor(Color.rgb(207, 207, 207));
                        btn.setOnClickListener(new View.OnClickListener() {
                            @Override
                            public void onClick(View v) {
                                if (aliyunVodPlayer != null &&
                                        (aliyunVodPlayer.getPlayerState() == IAliyunVodPlayer.PlayerState.Paused
                                                || aliyunVodPlayer.getPlayerState() == IAliyunVodPlayer.PlayerState.Started)) {
                                    Button fouces = (Button) v;
                                    fouces.setTextColor(Color.rgb(255, 255, 255));
                                    fouces.setBackgroundColor(Color.rgb(3, 106, 150));
                                    logStrs.add(format.format(new Date()) + " 请求切换清晰度至：" + fouces.getText());
                                    //refreshPlaySource();
                                    aliyunVodPlayer.changeQuality((String) fouces.getTag());
                                    for (Button otherBtn : qualityIds) {
                                        if (!otherBtn.equals(fouces)) {
                                            otherBtn.setTextColor(Color.rgb(49, 50, 51));
                                            otherBtn.setBackgroundColor(getResources().getColor(R.color.alivc_info_text_duration));
                                        }
                                    }

                                }
                            }
                        });
                        if (current.equals(quality)) {
                            btn.setTextColor(Color.rgb(255, 255, 255));
                            btn.setBackgroundColor(Color.rgb(3, 106, 150));
                        }
                        qualityIds.add(btn);
                        qualityLayout.addView(btn, layoutParams);

                    }
                }


                if(sAutoPlay || mAutoPlay) {
                    aliyunVodPlayer.start();
                    pauseBtn.setText("暂停");
                    logStrs.add(format.format(new Date()) + " 开始请求播放");
                    if(mMute) {
                        aliyunVodPlayer.setMuteMode(mMute);
                    }
                    brightnessBar.setProgress(aliyunVodPlayer.getScreenBrightness());
                    volumeBar.setProgress(aliyunVodPlayer.getVolume());
                }
                mAutoPlay = false;
            }
        });
        aliyunVodPlayer.setOnFirstFrameStartListener(new IAliyunVodPlayer.OnFirstFrameStartListener() {
            @Override
            public void onFirstFrameStart() {
                Map<String, String> debugInfo = aliyunVodPlayer.getAllDebugInfo();
                long createPts = 0;
                if(debugInfo.get("create_player") != null) {
                    String time = debugInfo.get("create_player");
                    createPts = (long)Double.parseDouble(time);
                    logStrs.add(format.format(new Date(createPts)) +" 播放创建成功");
                }
                if(debugInfo.get("open-url") != null) {
                    String time = debugInfo.get("open-url");
                    long openPts = (long)Double.parseDouble(time) + createPts;
                    logStrs.add(format.format(new Date(openPts)) +" url请求成功");
                }
                if(debugInfo.get("find-stream") != null) {
                    String time = debugInfo.get("find-stream");
                    VcPlayerLog.d(TAG + "lfj0914","find-Stream time =" + time + " , createpts = " + createPts);
                    long findPts = (long)Double.parseDouble(time) + createPts;
                    logStrs.add(format.format(new Date(findPts)) +" 请求流成功");
                }
                if(debugInfo.get("open-stream") != null) {
                    String time = debugInfo.get("open-stream");
                    VcPlayerLog.d(TAG + "lfj0914","open-Stream time =" + time + " , createpts = " + createPts);
                    long openPts = (long)Double.parseDouble(time) + createPts;
                    logStrs.add(format.format(new Date(openPts)) +" 开始传输码流");
                }
                logStrs.add(format.format(new Date()) +" 第一帧播放完成");
            }
        });
        aliyunVodPlayer.setOnErrorListener(new IAliyunVodPlayer.OnErrorListener() {
            @Override
            public void onError(int arg0, int arg1, String msg) {

                if(arg0 == AliyunErrorCode.ALIVC_ERR_INVALID_INPUTFILE.getCode()){
                    //当播放本地报错4003的时候，可能是文件地址不对，也有可能是没有权限。
                    //如果是没有权限导致的，就做一个权限的错误提示。其他还是正常提示：
                    int storagePermissionRet = ContextCompat.checkSelfPermission(NoSkinActivity.this, Manifest.permission.WRITE_EXTERNAL_STORAGE);
                    if(storagePermissionRet != PackageManager.PERMISSION_GRANTED){
                        Toast.makeText(NoSkinActivity.this, "失败！！！！原因：无本地存储访问权限", Toast.LENGTH_SHORT).show();
                        return;
                    }
                }

                Toast.makeText(NoSkinActivity.this, "失败！！！！原因：" + msg, Toast.LENGTH_SHORT).show();
            }
        });
        aliyunVodPlayer.setOnCompletionListener(new IAliyunVodPlayer.OnCompletionListener() {
            @Override
            public void onCompletion() {
                Log.d(TAG, "播放结束--- ");
                isCompleted = true;
                showVideoProgressInfo();
                stopUpdateTimer();
            }
        });
        aliyunVodPlayer.setOnSeekCompleteListener(new IAliyunVodPlayer.OnSeekCompleteListener() {
            @Override
            public void onSeekComplete() {
                logStrs.add(format.format(new Date()) + " seek结束");
                inSeek = false;
            }
        });
        aliyunVodPlayer.setOnStoppedListner(new IAliyunVodPlayer.OnStoppedListener() {
            @Override
            public void onStopped() {
                logStrs.add(format.format(new Date()) + "播放停止");
                if(replay) {
                    logStrs.add(format.format(new Date()) + " 准备请求码流");
                    if(mVidSource != null) {
                        aliyunVodPlayer.prepareAsync(mVidSource);
                    } else if(mPlayAuth != null) {
                        aliyunVodPlayer.prepareAsync(mPlayAuth);
                    } else if(mLocalSource != null) {
                        aliyunVodPlayer.prepareAsync(mLocalSource);
                    }
//                    else {
//                        aliyunVodPlayer.prepareAsync(mDataSource);
//                    }
                    mAutoPlay = true;
                }
                replay = false;
            }
        });
        aliyunVodPlayer.setOnBufferingUpdateListener(new IAliyunVodPlayer.OnBufferingUpdateListener() {
            @Override
            public void onBufferingUpdate(int percent) {
                Log.d(TAG, "缓冲进度更新--- " + percent);
                updateBufferingProgress(percent);
            }
        });
//        aliyunVodPlayer.setDisplay(surfaceView.getHolder());
        aliyunVodPlayer.setOnChangeQualityListener(new IAliyunVodPlayer.OnChangeQualityListener() {
            @Override
            public void onChangeQualitySuccess(String finalQuality) {
                Log.d(TAG, "切换清晰度成功");
                logStrs.add(format.format(new Date()) + " 切换清晰度成功");
                showVideoProgressInfo();
            }

            @Override
            public void onChangeQualityFail(int code, String msg) {
                Log.d(TAG, "切换清晰度失败。。。" + code + " ,  " + msg);
                logStrs.add(format.format(new Date()) + " 切换清晰度失败");
            }
        });
        aliyunVodPlayer.enableNativeLog();


    }

    private void refreshPlaySource()
    {
        mAuthinfo = null;
        new Thread(new Runnable() {

            //            @RequiresApi(api = Build.VERSION_CODES.KITKAT)
            @Override
            public void run() {
                mAuthinfo = PlayAuthUtil.getPlayAuth(NoSkinActivity.this,mVid);
            }
        }).start();

        int tryCount = 0;
        while (mAuthinfo == null || mAuthinfo.isEmpty()) {
            try {
                Thread.sleep(1000);
                tryCount++;
                if(tryCount > 5) {
                    Toast.makeText(NoSkinActivity.this, "通过网络请求authinfo失败", Toast.LENGTH_LONG).show();
                    break;
                }
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }

        AliyunPlayAuth.AliyunPlayAuthBuilder aliyunPlayAuthBuilder = new AliyunPlayAuth.AliyunPlayAuthBuilder();
        aliyunPlayAuthBuilder.setVid(mVid);
        aliyunPlayAuthBuilder.setPlayAuth(mAuthinfo);
        aliyunPlayAuthBuilder.setQuality(aliyunVodPlayer.getCurrentQuality());
        //aliyunVodPlayer.setAuthInfo(aliyunPlayAuthBuilder.build());
        mPlayAuth = aliyunPlayAuthBuilder.build();
    }

    private void setPlaySource() {
        String type = getIntent().getStringExtra("type");
//        if ("datasource".equals(type)) {
////        构建播放数据源
//            AliyunDataSource.AliyunDataSourceBuilder aliyunDataSourceBuilder = new AliyunDataSource.AliyunDataSourceBuilder(this);
//            mVid = getIntent().getStringExtra("vid");
//            String keyId = getIntent().getStringExtra("keyid");
//            String secret = getIntent().getStringExtra("secret");
//            String playKey = getIntent().getStringExtra("playKey");
//            aliyunDataSourceBuilder.setAccessKeySecret(secret);
//            aliyunDataSourceBuilder.setVideoId(mVid);
//            aliyunDataSourceBuilder.setPlayKey(playKey);
//            aliyunDataSourceBuilder.setAccessKeyId(keyId);
//            aliyunDataSourceBuilder.setQuality(IAliyunVodPlayer.QualityValue.QUALITY_ORIGINAL);
//            AliyunDataSource aliyunDataSource = aliyunDataSourceBuilder.build();
//            mDataSource = aliyunDataSource;
//        } else
            if ("authInfo".equals(type)) {

            //auth方式

            //NOTE： 注意过期时间。特别是重播的时候，可能已经过期。所以重播的时候最好重新请求一次服务器。
            mVid = getIntent().getStringExtra("vid").toString();
            String authInfo = getIntent().getStringExtra("authinfo");
            AliyunPlayAuth.AliyunPlayAuthBuilder aliyunPlayAuthBuilder = new AliyunPlayAuth.AliyunPlayAuthBuilder();
            aliyunPlayAuthBuilder.setVid(mVid);
            aliyunPlayAuthBuilder.setPlayAuth(authInfo);

//            qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_FLUENT,"流畅");
//            qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_LOW,"标清");
//            qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_STAND,"高清");
//            qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_HIGH,"超清");
//            qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_2K,"2k");
//            qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_4K,"4k");
//            qualityList.put(IAliyunVodPlayer.QualityValue.QUALITY_ORIGINAL,"原画");
            aliyunPlayAuthBuilder.setQuality(IAliyunVodPlayer.QualityValue.QUALITY_STAND);
            //aliyunVodPlayer.setAuthInfo(aliyunPlayAuthBuilder.build());
            mPlayAuth = aliyunPlayAuthBuilder.build();
        } else if ("localSource".equals(type)) {
            //本地播放
            String url = getIntent().getStringExtra("url");
            AliyunLocalSource.AliyunLocalSourceBuilder asb = new AliyunLocalSource.AliyunLocalSourceBuilder();
            asb.setSource(url);
            //aliyunVodPlayer.setLocalSource(asb.build());
            mLocalSource = asb.build();
        }  else if("vidSource".equals(type)) {
            mVid = getIntent().getStringExtra("vid").toString();
            mVidSource = new AliyunVidSource();
            String authInfo = getIntent().getStringExtra("authinfo");
            String token = getIntent().getStringExtra("token");
            String akid = getIntent().getStringExtra("akid");
            String aks = getIntent().getStringExtra("aks");
            mVidSource.setVid(mVid);
            mVidSource.setAuthInfo(authInfo);
            mVidSource.setStsToken(token);
            mVidSource.setAcKey(aks);
            mVidSource.setAcId(akid);
            mVidSource.setDomainRegion("cn-shanghai");
            //mVidSource.setDomain("vod-test5.cn-shanghai.aliyuncs.com");
            mVidSource.setDomain("jiyoujia.com");
        }
    }

//    /**
//     * 重播功能。
//     */
//    private void replay() {
//        //replay有两种形式，
//        //一种是保留播放器，在onstopped的回调函数内prepare
//        //在surface不变的情况下，建议用这种
//        if(true) {
//            AliyunVodPlayer tmpVodPlayer = aliyunVodPlayer;
//            if (tmpVodPlayer != null) {
//                logStrs.add(format.format(new Date()) + " 请求停止播放");
//                tmpVodPlayer.stop();
//                if(mPlayAuth != null) {
//                    refreshPlaySource();//如果是用的auth模式，注意过期时间。
//                }
//                replay = true;
//            }
//        }
//        //一种是将上一个播放器stop & release 彻底释放，再重新开启播放器
//        //切换了surface或者重置了surface的情况下，建议用这种
//        else {
//            AliyunVodPlayer tmpVodPlayer = aliyunVodPlayer;
//            if (tmpVodPlayer != null) {
//                logStrs.add(format.format(new Date()) + " 播放停止");
//                tmpVodPlayer.stop();
//                logStrs.add(format.format(new Date()) + " 请求释放播放器资源");
//                tmpVodPlayer.release();
//            }
//            aliyunVodPlayer = null;
//            stopUpdateTimer();
//
//            initVodPlayer();
//            refreshPlaySource();//如果是用的auth模式，注意过期时间。
//
//            if (surfaceView != null) {
//                //刷新surfaceHolder
//                surfaceView.setVisibility(View.GONE);
//                surfaceView.setVisibility(View.VISIBLE);
//            }
//            logStrs.add(format.format(new Date()) + " 准备请求码流");
//            if(mVidSource != null) {
//                aliyunVodPlayer.prepareAsync(mVidSource);
//            } else if(mPlayAuth != null) {
//                aliyunVodPlayer.prepareAsync(mPlayAuth);
//            } else if(mLocalSource != null) {
//                aliyunVodPlayer.prepareAsync(mLocalSource);
//            } else {
//                aliyunVodPlayer.prepareAsync(mDataSource);
//            }
//        }
//    }

    private void showVideoSizeInfo() {
        videoWidthTxt.setText("视频宽：" + aliyunVodPlayer.getVideoWidth() + " , ");
        videoHeightTxt.setText("视频高：" + aliyunVodPlayer.getVideoHeight() + "   ");
    }

    private void updateBufferingProgress(int percent) {
        int duration = (int) aliyunVodPlayer.getDuration();
        int secondaryProgress = (int) (duration * percent * 1.0f / 100);
        Log.d(TAG, "lfj0918 duration = " + duration + " , buffer percent = " +percent + " , secondaryProgress =" + secondaryProgress);
        progressBar.setSecondaryProgress(secondaryProgress);
    }

    private void showVideoProgressInfo() {
        if((aliyunVodPlayer.getPlayerState().equals(AliyunVodPlayer.PlayerState.Started)
                || aliyunVodPlayer.getPlayerState().equals(AliyunVodPlayer.PlayerState.Replay))
                && !inSeek) {
            int curPosition = (int) aliyunVodPlayer.getCurrentPosition();
            positionTxt.setText(Formatter.formatTime(curPosition));
            int duration = (int) aliyunVodPlayer.getDuration();
            durationTxt.setText(Formatter.formatTime(duration));
            Log.d(TAG, "lfj0918 duration = " + duration + " , curPosition = " + curPosition );
            progressBar.setMax(duration);
            progressBar.setProgress(curPosition);
        }

        startUpdateTimer();
    }

    private void startUpdateTimer() {
        Log.d(TAG, "播放进度更新--- ");
        progressUpdateTimer.removeMessages(0);
        progressUpdateTimer.sendEmptyMessageDelayed(0, 1000);
    }

    private void stopUpdateTimer() {
        progressUpdateTimer.removeMessages(0);
    }

    private Handler progressUpdateTimer = new Handler() {
        @Override
        public void handleMessage(Message msg) {

            showVideoProgressInfo();
        }
    };

    @Override
    protected void onResume() {
        super.onResume();
        //保存播放器的状态，供resume恢复使用。
        resumePlayerState();
    }

    @Override
    protected void onStop() {
        super.onStop();
        //onStop中记录下来的状态，在这里恢复使用
        savePlayerState();
    }


    //用来记录前后台切换时的状态，以供恢复。
    private IAliyunVodPlayer.PlayerState mPlayerState;

    private void resumePlayerState() {
        if (mPlayerState == IAliyunVodPlayer.PlayerState.Paused) {
            aliyunVodPlayer.pause();
        } else if (mPlayerState == IAliyunVodPlayer.PlayerState.Started) {
            aliyunVodPlayer.start();
            pauseBtn.setText("暂停");
        }
    }

    private void savePlayerState() {
        mPlayerState = aliyunVodPlayer.getPlayerState();
        if (aliyunVodPlayer.isPlaying()) {
            //然后再暂停播放器
            aliyunVodPlayer.pause();
        }
    }

    @Override
    protected void onDestroy() {
        aliyunVodPlayer.stop();
        aliyunVodPlayer.release();
        stopUpdateTimer();
        progressUpdateTimer = null;

        super.onDestroy();
    }

    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
        int orientation = getResources().getConfiguration().orientation;
        if (orientation == Configuration.ORIENTATION_PORTRAIT) {                //转为竖屏了。
            //显示状态栏
            this.getWindow().clearFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
            surfaceView.setSystemUiVisibility(View.SYSTEM_UI_FLAG_VISIBLE);

            //设置view的布局，宽高之类
            ViewGroup.LayoutParams surfaceViewLayoutParams = surfaceView.getLayoutParams();
            surfaceViewLayoutParams.height = (int) (ScreenUtils.getWight(this) * 9.0f / 16);
            surfaceViewLayoutParams.width = ViewGroup.LayoutParams.MATCH_PARENT;

        } else if (orientation == Configuration.ORIENTATION_LANDSCAPE) {                //转到横屏了。
            //隐藏状态栏
            this.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
            surfaceView.setSystemUiVisibility(View.SYSTEM_UI_FLAG_HIDE_NAVIGATION
                    | View.SYSTEM_UI_FLAG_FULLSCREEN);
            //设置view的布局，宽高
            ViewGroup.LayoutParams surfaceViewLayoutParams = surfaceView.getLayoutParams();
            surfaceViewLayoutParams.height = ViewGroup.LayoutParams.MATCH_PARENT;
            surfaceViewLayoutParams.width = ViewGroup.LayoutParams.MATCH_PARENT;

        }
    }

    AliyunDownloadInfoListener downloadInfoListener = new AliyunDownloadInfoListener() {
        @Override
        public void onPrepared(List<AliyunDownloadMediaInfo> infos) {
            AliyunDataSource.AliyunDataSourceBuilder aliyunDataSourceBuilder = new AliyunDataSource.AliyunDataSourceBuilder(NoSkinActivity.this);
            String vid = getIntent().getStringExtra("vid");
            String keyId = getIntent().getStringExtra("keyid");
            String secret = getIntent().getStringExtra("secret");
            String playKey = getIntent().getStringExtra("playKey");
            aliyunDataSourceBuilder.setAccessKeySecret(secret);
            aliyunDataSourceBuilder.setVideoId(vid);
            aliyunDataSourceBuilder.setPlayKey(playKey);
            aliyunDataSourceBuilder.setAccessKeyId(keyId);
            aliyunDataSourceBuilder.setTitle(infos.get(0).getTitle());
            aliyunDataSourceBuilder.setQuality(infos.get(0).getQuality());
            aliyunDataSourceBuilder.setFormat(infos.get(0).getFormat());
            AliyunDataSource aliyunDataSource = aliyunDataSourceBuilder.build();
            aliyunDownloadManager.startDownloadMedia(aliyunDataSource);
        }

        @Override
        public void onStart(AliyunDownloadMediaInfo info) {

            downloadInfo = info;
            Toast.makeText(NoSkinActivity.this, "下载开始", Toast.LENGTH_LONG).show();
        }

        @Override
        public void onProgress(AliyunDownloadMediaInfo info, int percent) {
            downloadInfo = info;
            Toast.makeText(NoSkinActivity.this, "下载进度。。" + percent + "%", Toast.LENGTH_SHORT).show();
        }

        @Override
        public void onStop(AliyunDownloadMediaInfo info) {
            downloadInfo = info;
            Toast.makeText(NoSkinActivity.this, "下载停止", Toast.LENGTH_LONG).show();
        }

        @Override
        public void onCompletion(AliyunDownloadMediaInfo info) {
            downloadInfo = info;
            Toast.makeText(NoSkinActivity.this, "下载结束", Toast.LENGTH_LONG).show();
        }

        @Override
        public void onError(AliyunDownloadMediaInfo info, int code, String msg) {
            downloadInfo = info;
            Toast.makeText(NoSkinActivity.this, "下载出错：" + msg, Toast.LENGTH_LONG).show();
        }

        @Override
        public void onWait(AliyunDownloadMediaInfo outMediaInfo) {
            downloadInfo = outMediaInfo;
            Toast.makeText(NoSkinActivity.this, "下载等待：", Toast.LENGTH_SHORT).show();

        }

        @Override
        public void onM3u8IndexUpdate(AliyunDownloadMediaInfo outMediaInfo, int index) {

        }
    };

}
